{ Sistema para gerao de banco de dados Access 2000
  Linguagem....: Delphi 6
  Base de dados: Access 2000
}
unit UCriaBase;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ADODB, DB, Buttons, OleServer, ADOX_TLB;

type
  TForm1 = class(TForm)
    ADOXCatalog1: TADOXCatalog;
    btnBase: TBitBtn;
    btnTabelas: TBitBtn;
    btnNavegar: TBitBtn;
    edtPath: TEdit;
    SaveDialog1: TSaveDialog;
    ADOConnection1: TADOConnection;
    ADOCommand1: TADOCommand;
    Label1: TLabel;
    procedure btnNavegarClick(Sender: TObject);
    procedure btnBaseClick(Sender: TObject);
    procedure btnTabelasClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btnNavegarClick(Sender: TObject);
begin
  if SaveDialog1.Execute then
    edtPath.Text := SaveDialog1.FileName;
end;

procedure TForm1.btnBaseClick(Sender: TObject);
var
  Base: String;
begin
  if edtPath.Text = '' then
  begin
    ShowMessage('Nome da base de dados no informada.');
    exit;
  end;
  //Se o seu MSAccess for 97 altere Jet OLEDB:Engine Type= de 5 para 4
  Base := 'Provider=Microsoft.Jet.OLEDB.4.0'+
          ';Data Source=' + edtPath.Text +
          ';Jet OLEDB:Engine Type=5';

  ADOXCatalog1.Create1(Base);
end;

procedure TForm1.btnTabelasClick(Sender: TObject);
var
  base, comando: string;
begin

  { definindo a base de dados }
  base := 'Provider=Microsoft.Jet.OLEDB.4.0' +
          ';Data Source=' + edtPath.Text +
          ';Jet OLEDB:Engine Type=4'+
          ';Persist Security Info=False';
  ADOConnection1.ConnectionString := base;

  { Criando as tabelas... }

  {>>> PROPRIETARIO <<<}
  comando := 'CREATE TABLE PROPRIETARIO (' +
                'PRO_ID INT,' +
                'PRO_NOME TEXT(50),'+
                'PRO_JURIDICA YESNO,'+
                'PRO_OBS MEMO)';

  ADOCommand1.CommandText := comando;
  ADOCommand1.Execute;

  { ADICIONANDO INDICES }
  comando := 'CREATE INDEX IDX_PRO_ID ' +
               'ON PROPRIETARIO (PRO_ID) WITH PRIMARY';

  ADOCommand1.CommandText := comando;
  ADOCommand1.Execute;

  {>>> ANIMAL <<<}
  comando := 'CREATE TABLE ANIMAL (' +
                'ANI_ID INT,' +
                'ANI_PROPRIETARIO INT ' +
                   'CONSTRAINT IDX_PRO_ID ' +
                   'REFERENCES PROPRIETARIO (PRO_ID),' +
                'ANI_NOME TEXT (50),' +
                'ANI_NASCIMENTO DATETIME)';

  ADOCommand1.CommandText := comando;
  ADOCommand1.Execute;
end;

end.
